<?php
	/*
     LogzMon 1.4, Log Viewer and Monitor, AddOn SYSLOG
     Copyright (C) 2007 methodica, Hans E. Herger

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation, version 3 of the License.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
     The author may UNDER NO CIRCUMSTANCES BE MADE LIABLE FOR ANY
     CONSEQUENCES OF USING THE PROGRAM. IF THIS WAIVER OF ALL LIABILITY
     CONTRADICTS THE LAW WHERE YOU INTEND TO USE THE PROGRAM ITS USE IS
     STRICTLY PROHIBITED.
     See the GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
	*/

 	function send_syslog($par='',$pat='(.*)',$msg='',$line='',$file='')
	{
	//  COFIGURATION BEGIN ------------------------------------------------------------
		$params = explode('|',$par);
		$facility = (isset($params[0]))?$params[0]:23;          // default: local7
		$severity = (isset($params[1]))?$params[1]:5;           // default: notice
		$hostname = (isset($params[2]))?$params[2]:'';
		$process  = (isset($params[3]))?$params[3]:'';
		$serverip = (isset($params[4]))?$params[4]:'127.0.0.1'; // default: locahost
		$serverport = (isset($params[5]))?$params[5]:514;       // default: 514
	//  COFIGURATION END --------------------------------------------------------------

		$ok = 1;

		while ($ok) {
		    if ( (empty($serverip)) || (empty($serverport)) ) { break; }
			$regex = '/'.$pat.'/s';
			$regs = array();
			ereg($pat, $line, $regs);
			preg_match($regex, $line, $regs);
			for ($i = 0; $i < count($regs); $i++) { $rg = '$'.$i; $msg = str_replace($rg, $regs[$i], $msg); }
			if (empty($msg)) { break; }
			$msg = str_replace('$file', $file, $msg);
			echo "<p><span style=\"color:#ffffff; background-color:#666666; font-weight:bold;\">&lt;SYSLOG&gt;</span>&nbsp;$msg</p>";

			$msg = str_replace('$line', $line, $msg);
			$msg = str_replace('\r',"\r",$msg);
			$msg = str_replace('\n',"\n",$msg);

			//connect to the host and port
     		require_once('syslog.php');
     		$syslog = new Syslog();
			$syslog->SetFacility($facility);
			$syslog->SetSeverity($severity);
			$syslog->SetHostname($hostname);
			$syslog->SetProcess($process);
			$syslog->SetContent($msg);
			$syslog->SetServer($serverip);
			$syslog->SetPort($serverport);
			$syslog->Send();
			return 0;
			break;
		} // while ($ok);
		return -1;

	} // function send_syslog...
?>
